//
// Created by philipp on 15.01.18.
//

#include "../include/Socket.h"

namespace networking
{
namespace socket
{
namespace internal
{

boost::asio::const_buffers_1 stringToBuffer(const std::string & str)
{
    // Adds '\0' to the buffer.
    return boost::asio::buffer(str.c_str(), str.size() + 1);
}

bool isLastCharacterNull(const std::vector<char> & buffer, std::size_t numBytes)
{
    if (numBytes == 0)
        return false;

    return buffer[numBytes - 1] == '\0';
}

std::string stringFromBuffer(const std::vector<char> & buffer, std::size_t numBytes)
{
    return std::string{buffer.begin(), buffer.begin() + numBytes};
}

}
}
}