//
// Created by philipp on 15.01.18.
//

#include "../include/Stream.h"

namespace networking
{
namespace stream
{
namespace internal
{

boost::asio::const_buffers_1 stringToBuffer(const std::string & str)
{
    // Adds '\0' to the buffer.
    return boost::asio::buffer(str.c_str(), str.size() + 1);
}

std::string stringFromStreambuf(boost::asio::streambuf & streambuf, std::size_t numBytes)
{
    using boost::asio::buffers_begin;
    if (numBytes == 0)
        return std::string{""};
    auto buffer = streambuf.data();
    auto result = std::string{buffers_begin(buffer), buffers_begin(buffer) + numBytes - 1};
    streambuf.consume(numBytes);
    return result;
}

}
}
}