//
// Created by philipp on 29.11.17.
//

#ifndef PROTOCOL_PLATOONINGPROTOCOL_H
#define PROTOCOL_PLATOONINGPROTOCOL_H

#include <cstdint>
#include <string>
#include <iostream>
#include <mutex>

namespace protocol
{
using VehicleId = std::uint32_t;
using MessageType = std::uint8_t;
using PlatoonId = std::uint32_t;
using PlatoonSpeed = float;
using InnerPlatoonDistance = float;

struct PlatoonConfig
{
    PlatoonSpeed platoonSpeed;
    InnerPlatoonDistance innerPlatoonDistance;

    bool operator==(const PlatoonConfig & other) const noexcept
    {
        return platoonSpeed == other.platoonSpeed && innerPlatoonDistance == other.innerPlatoonDistance;
    }

    bool operator!=(const PlatoonConfig & other) const noexcept
    {
        return !(*this == other);
    }
};

#define DEBUG

template<typename... Ts>
inline void log(const Ts &... args)
{
#ifdef DEBUG
    static std::mutex logMutex;
    std::lock_guard<std::mutex> lock(logMutex);
    auto l = {(std::cout << args, true)...};
    std::cout.flush();
#endif
};

}

#endif //PROTOCOL_PLATOONINGPROTOCOL_H
